package com.yakindu.ea.examples.orderingsoftware.template.core

import java.util.List
import org.eclipse.core.resources.IFile
import org.eclipse.core.runtime.Path
import org.eclipse.uml2.uml.Class
import org.eclipse.uml2.uml.Package

import static extension com.yakindu.ea.examples.orderingsoftware.template.util.JavaUtils.*

abstract class PersistenceManagerTemplate extends AbstractTemplate {
	def IFile path(Package element, IFile defaultFile) {
		return defaultFile.parent.getFile(new Path("PersistenceManager." + defaultFile.fileExtension));
	}
	
	def String generate(Package element) {
		if (shouldGenerate(element)) {
			return generatePersistenceManager(element)
		}
	}
	
	protected def boolean shouldGenerate(Package element) {
		return !collectClasses(element).isNullOrEmpty
	}
	
	protected abstract def String generatePersistenceManager(Package element);
	
	protected def String printClassComment() '''
		/**
		 * This file was generated by {@link «class.name»}!
		 */
	'''
	
	protected def String printPackageDeclaration(Package element) '''
		package «element.javaQualifiedName»;
	'''
	
	protected def List<Class> collectClasses(Package element) {
		return element.ownedElements.filter[it instanceof Class].map[it as Class].filter[!abstract].sortBy[name]
	}
}